--- old/usr/src/uts/common/inet/ip.h	2012-08-18 10:37:12.689029022 +0000
+++ new/usr/src/uts/common/inet/ip.h	2012-08-18 10:37:12.730507448 +0000
@@ -84,6 +84,10 @@
 
 #define	SCTP_MOD_NAME	"sctp"
 
+#define	DCCP_MOD_NAME	"dccp"
+#define	DCCP_DEV_NAME	"/dev/dccp"
+#define	DCCP6_DEV_NAME	"/dev/dccp6"
+
 #ifndef	_IPADDR_T
 #define	_IPADDR_T
 typedef uint32_t ipaddr_t;
@@ -217,6 +221,7 @@
 #define	Q_TO_UDP(q)	(Q_TO_CONN((q))->conn_udp)
 #define	Q_TO_ICMP(q)	(Q_TO_CONN((q))->conn_icmp)
 #define	Q_TO_RTS(q)	(Q_TO_CONN((q))->conn_rts)
+#define	Q_TO_DCCP(q)	(Q_TO_CONN((q))->conn_dccp)
 
 #define	CONNP_TO_WQ(connp)	((connp)->conn_wq)
 #define	CONNP_TO_RQ(connp)	((connp)->conn_rq)
@@ -3748,6 +3753,13 @@
 #define	SQTAG_TCP_SHUTDOWN_OUTPUT	43
 #define	SQTAG_TCP_IXA_CLEANUP		44
 #define	SQTAG_TCP_SEND_SYNACK		45
+#define	SQTAG_IP_DCCP_INPUT		46
+#define	SQTAG_DCCP_OUTPUT		47
+#define	SQTAG_DCCP_CONN_REQ_UNBOUND	48
+#define	SQTAG_DCCP_SEND_RESPONSE	49
+#define	SQTAG_IP_DCCP_CLOSE		50
+#define	SQTAG_DCCP_TIMER		51
+#define	SQTAG_DCCP_SHUTDOWN_OUTPUT	52
 
 extern sin_t	sin_null;	/* Zero address for quick clears */
 extern sin6_t	sin6_null;	/* Zero address for quick clears */
--- old/usr/src/uts/common/inet/ip/ip.c	2012-08-18 10:37:13.245774637 +0000
+++ new/usr/src/uts/common/inet/ip/ip.c	2012-08-18 10:37:13.581747168 +0000
@@ -111,6 +111,9 @@
 #include <ipp/ipgpc/ipgpc.h>
 
 #include <sys/pattr.h>
+#include <inet/dccp.h>
+#include <inet/dccp_impl.h>
+#include <inet/dccp_ip.h>
 #include <inet/ipclassifier.h>
 #include <inet/sctp_ip.h>
 #include <inet/sctp/sctp_impl.h>
@@ -1821,6 +1824,38 @@
 		    mp->b_wptr)
 			goto truncated;
 		break;
+	case IPPROTO_DCCP: {
+		dccpha_t	*dccpha;
+
+		/*
+		 * Verify we have at least ICMP_MIN_TP_HDR_LEN bytes of
+		 * transport header.
+		 */
+		if ((uchar_t *)ipha + hdr_length + ICMP_MIN_TP_HDR_LEN >
+		    mp->b_wptr)
+			goto truncated;
+
+		cmn_err(CE_NOTE, "icmp_inbound_verify_v4");
+
+		dccpha = (dccpha_t *)((uchar_t *)ipha + hdr_length);
+		/* XXX:DCCP */
+/*
+		connp = ipcl_dccp_lookup_reversed_ipv4(ipha, dccpha,
+		    DCCPS_LISTEN, ipst);
+		if (connp == NULL) {
+			goto discard_pkt;
+		}
+
+		if ((connp->conn_verifyicmp != NULL) &&
+		    !connp->conn_verifyicmp(connp, dccpha, icmph, NULL, ira)) {
+			CONN_DEC_REF(connp);
+			goto discard_pkt;
+		}
+
+		CONN_DEC_REF(connp);
+*/
+		break;
+	}
 	case IPPROTO_ESP:
 	case IPPROTO_AH:
 		break;
@@ -2169,6 +2204,10 @@
 		ira->ira_flags &= ~IRAF_ICMP_ERROR;
 		return;
 
+	case IPPROTO_DCCP:
+		cmn_err(CE_NOTE, "icmp_inbound_error_fanout_v4");
+		return;
+
 	case IPPROTO_ESP:
 	case IPPROTO_AH:
 		if (!ipsec_loaded(ipss)) {
@@ -4311,6 +4350,7 @@
 	icmp_ddi_g_destroy();
 	rts_ddi_g_destroy();
 	udp_ddi_g_destroy();
+	dccp_ddi_g_destroy();
 	sctp_ddi_g_destroy();
 	tcp_ddi_g_destroy();
 	ilb_ddi_g_destroy();
@@ -4547,6 +4587,7 @@
 	ipsec_policy_g_init();
 	tcp_ddi_g_init();
 	sctp_ddi_g_init();
+	dccp_ddi_g_init();
 	dce_g_init();
 
 	/*
@@ -9684,9 +9725,15 @@
 	if ((mpctl = sctp_snmp_get_mib2(q, mpctl, sctps)) == NULL) {
 		return (1);
 	}
+
 	if ((mpctl = ip_snmp_get_mib2_ip_dce(q, mpctl, ipst)) == NULL) {
 		return (1);
 	}
+
+	if ((mpctl = dccp_snmp_get(q, mpctl, legacy_req)) == NULL) {
+		return (1);
+	}
+
 	freemsg(mpctl);
 	return (1);
 }
@@ -15237,6 +15284,7 @@
 		cpu_seqid = cpu[id]->cpu_seqid;
 		netstack_next_init(&nh);
 		while ((ns = netstack_next(&nh)) != NULL) {
+			dccp_stack_cpu_add(ns->netstack_dccp, cpu_seqid);
 			tcp_stack_cpu_add(ns->netstack_tcp, cpu_seqid);
 			sctp_stack_cpu_add(ns->netstack_sctp, cpu_seqid);
 			udp_stack_cpu_add(ns->netstack_udp, cpu_seqid);
--- old/usr/src/uts/common/inet/ip/ip_if.c	2012-08-18 10:37:14.683210510 +0000
+++ new/usr/src/uts/common/inet/ip/ip_if.c	2012-08-18 10:37:14.997967749 +0000
@@ -104,6 +104,7 @@
 
 #include <inet/rawip_impl.h> /* needed for icmp_stack_t */
 #include <inet/udp_impl.h> /* needed for udp_stack_t */
+#include <inet/dccp_stack.h> /* needed for dccp_stack_t */
 
 /* The character which tells where the ill_name ends */
 #define	IPIF_SEPARATOR_CHAR	':'
@@ -8857,6 +8858,7 @@
 	icmp_stack_t	*is;
 	tcp_stack_t	*tcps;
 	sctp_stack_t	*sctps;
+	dccp_stack_t	*dccps;
 	udp_stack_t	*us;
 	netstack_t	*stack;
 	void		*cbarg;
@@ -8902,6 +8904,10 @@
 		ptbl = sctps->sctps_propinfo_tbl;
 		cbarg = sctps;
 		break;
+	case MOD_PROTO_DCCP:
+		dccps = stack->netstack_dccp;
+		ptbl = dccps->dccps_propinfo_tbl;
+		cbarg = dccps;
 	default:
 		miocnak(q, mp, 0, EINVAL);
 		return;
--- old/usr/src/uts/common/inet/ip/ip_input.c	2012-08-18 10:37:16.127929169 +0000
+++ new/usr/src/uts/common/inet/ip/ip_input.c	2012-08-18 10:37:16.138656527 +0000
@@ -116,6 +116,7 @@
 #include <inet/sctp_ip.h>
 #include <inet/sctp/sctp_impl.h>
 #include <inet/udp_impl.h>
+#include <inet/dccp_impl.h>
 #include <sys/sunddi.h>
 
 #include <sys/tsol/label.h>
@@ -2389,6 +2390,9 @@
 	case IPPROTO_ICMP:
 		min_ulp_header_length = ICMPH_SIZE;
 		break;
+	case IPPROTO_DCCP:
+		min_ulp_header_length = DCCP_MIN_HEADER_LENGTH;
+		break;
 	default:
 		min_ulp_header_length = 0;
 		break;
@@ -2714,6 +2718,69 @@
 		ira->ira_ill = ill;
 		ira->ira_rill = rill;
 		return;
+	case IPPROTO_DCCP:
+		/* For DCCP, discard broadcast and multicast packets */
+		if (iraflags & IRAF_MULTIBROADCAST) {
+			goto discard;
+		}
+
+		/* First mblk contains IP+DCCP headers per above check */
+		ASSERT(len >= ip_hdr_length + DCCP_MIN_HEADER_LENGTH);
+
+		/* Squeue hint */
+		if (ira->ira_sqp == NULL) {
+			ira->ira_sqp = ip_squeue_get(ira->ira_ring);
+		}
+
+		connp = ipcl_classify_v4(mp, IPPROTO_DCCP, ip_hdr_length,
+		    ira, ipst);
+		if (connp == NULL) {
+			cmn_err(CE_NOTE, "ip_input.c: ip_fanout_v4 connp not found");
+			/* Send the reset packet */
+			BUMP_MIB(ill->ill_ip_mib, ipIfStatsHCInDelivers);
+			dccp_xmit_listeners_reset(mp, ira, ipst, NULL);
+			return;
+		}
+
+		if (connp->conn_incoming_ifindex != 0 &&
+		    connp->conn_incoming_ifindex != ira->ira_ruifindex) {
+			cmn_err(CE_NOTE, "ip_input.c: ip_fanout_v4 ifindex problem");
+			/* Send the reset packet */
+			BUMP_MIB(ill->ill_ip_mib, ipIfStatsHCInDelivers);
+			dccp_xmit_listeners_reset(mp, ira, ipst, NULL);
+			return;
+		}
+
+		if (CONN_INBOUND_POLICY_PRESENT(connp, ipss) ||
+		    (iraflags & IRAF_IPSEC_SECURE)) {
+			mp = ipsec_check_inbound_policy(mp, connp,
+			    ipha, NULL, ira);
+			if (mp == NULL) {
+				BUMP_MIB(ill->ill_ip_mib, ipIfStatsInDiscards);
+				/* Note that mp is NULL */
+				ip_drop_input("ipIfStatsInDiscards", mp, ill);
+				CONN_DEC_REF(connp);
+				return;
+			}
+		}
+
+		/* Found a client; up it goes */
+		BUMP_MIB(ill->ill_ip_mib, ipIfStatsHCInDelivers);
+		ira->ira_ill = ira->ira_rill = NULL;
+
+		/* XXX SOCK_RAW for DCCP? */
+
+		if (iraflags & IRAF_TARGET_SQP) {
+			cmn_err(CE_NOTE, "IRAF_TARGET_SQP");
+		} else {
+			SQUEUE_ENTER_ONE(connp->conn_sqp, mp, connp->conn_recv,
+			    connp, ira, ip_squeue_flag, SQTAG_IP_DCCP_INPUT);
+		}
+
+		ira->ira_ill = ill;
+		ira->ira_rill = rill;
+		return;
+
 	default:
 		break;
 	}
--- old/usr/src/uts/common/inet/ip/ip_output.c	2012-08-18 10:37:16.594572839 +0000
+++ new/usr/src/uts/common/inet/ip/ip_output.c	2012-08-18 10:37:16.626507390 +0000
@@ -1648,6 +1648,9 @@
 #endif
 			sctph->sh_chksum = sctp_cksum(mp, ip_hdr_length);
 		goto ip_hdr_cksum;
+	} else if (protocol == IPPROTO_DCCP) {
+		cksump = IPH_DCCPH_CHECKSUMP(ipha, ip_hdr_length);
+		cksum = IP_DCCP_CSUM_COMP;
 	} else {
 		goto ip_hdr_cksum;
 	}
@@ -1737,6 +1740,9 @@
 #endif
 			sctph->sh_chksum = sctp_cksum(mp, ip_hdr_length);
 		goto ip_hdr_cksum;
+	} else if (protocol == IPPROTO_DCCP) {
+		cksump = IPH_DCCPH_CHECKSUMP(ipha, ip_hdr_length);
+		cksum = IP_DCCP_CSUM_COMP;
 	} else {
 	ip_hdr_cksum:
 		/* Calculate IPv4 header checksum */
--- old/usr/src/uts/common/inet/ip/ipclassifier.c	2012-08-18 10:37:17.022739851 +0000
+++ new/usr/src/uts/common/inet/ip/ipclassifier.c	2012-08-18 10:37:17.059476558 +0000
@@ -67,6 +67,8 @@
  *	ipcl_udp_fanout:	contains all UDP connections
  *	ipcl_iptun_fanout:	contains all IP tunnel connections
  *	ipcl_globalhash_fanout:	contains all connections
+ *`	ipcl_dccp_conn_fanout:	contains all DCCP connections in CONNECTED state
+ *	ipcl_dccp_bind_fanout:	contains all DCCP connections in BOUND state
  *
  * The ipcl_globalhash_fanout is used for any walkers (like snmp and Clustering)
  * which need to view all existing connections.
@@ -223,6 +225,7 @@
  *		IPCL_UDPCONN	indicates a UDP conn_t.
  *		IPCL_RAWIPCONN	indicates a RAWIP/ICMP conn_t.
  *		IPCL_RTSCONN	indicates a RTS conn_t.
+ *		IPCL_DCCPCONN	indicates a DCCP conn_t.
  *		IPCL_IPCCONN	indicates all other connections.
  *
  * void ipcl_conn_destroy(connp)
@@ -257,6 +260,7 @@
 #include <inet/ip_ndp.h>
 #include <inet/ip_impl.h>
 #include <inet/udp_impl.h>
+#include <inet/dccp_impl.h>
 #include <inet/sctp_ip.h>
 #include <inet/sctp/sctp_impl.h>
 #include <inet/rawip_impl.h>
@@ -284,6 +288,10 @@
 uint_t ipcl_bind_fanout_size = 512;
 uint_t ipcl_udp_fanout_size = 16384;
 
+/* Fanout table sizes for dccp */
+uint_t ipcl_dccp_conn_fanout_size = 512;
+uint_t ipcl_dccp_bind_fanout_size = 512;
+
 /* Raw socket fanout size.  Must be a power of 2. */
 uint_t ipcl_raw_fanout_size = 256;
 
@@ -319,6 +327,7 @@
 struct kmem_cache  *udp_conn_cache;
 struct kmem_cache  *rawip_conn_cache;
 struct kmem_cache  *rts_conn_cache;
+struct kmem_cache  *dccp_conn_cache;
 
 extern void	tcp_timermp_free(tcp_t *);
 extern mblk_t	*tcp_timermp_alloc(int);
@@ -338,6 +347,9 @@
 static int	rts_conn_constructor(void *, void *, int);
 static void	rts_conn_destructor(void *, void *);
 
+static int	dccp_conn_constructor(void *, void *, int);
+static void	dccp_conn_destructor(void *, void *);
+
 /*
  * Global (for all stack instances) init routine
  */
@@ -368,6 +380,12 @@
 	    sizeof (itc_t) + sizeof (rts_t), CACHE_ALIGN_SIZE,
 	    rts_conn_constructor, rts_conn_destructor,
 	    NULL, NULL, NULL, 0);
+
+	/* XXX:DCCP reclaim */
+	dccp_conn_cache = kmem_cache_create("dccp_conn_cache",
+	    sizeof (itc_t) + sizeof (dccp_t), CACHE_ALIGN_SIZE,
+	    dccp_conn_constructor, dccp_conn_destructor,
+	    NULL, NULL, NULL, 0);
 }
 
 /*
@@ -410,6 +428,8 @@
 
 	/* Take values from /etc/system */
 	ipst->ips_ipcl_bind_fanout_size = ipcl_bind_fanout_size;
+	ipst->ips_ipcl_dccp_conn_fanout_size = ipcl_dccp_conn_fanout_size;
+	ipst->ips_ipcl_dccp_bind_fanout_size = ipcl_dccp_bind_fanout_size;
 	ipst->ips_ipcl_udp_fanout_size = ipcl_udp_fanout_size;
 	ipst->ips_ipcl_raw_fanout_size = ipcl_raw_fanout_size;
 	ipst->ips_ipcl_iptun_fanout_size = ipcl_iptun_fanout_size;
@@ -477,6 +497,20 @@
 		mutex_init(&ipst->ips_ipcl_globalhash_fanout[i].connf_lock,
 		    NULL, MUTEX_DEFAULT, NULL);
 	}
+
+	ipst->ips_ipcl_dccp_conn_fanout = kmem_zalloc(
+	    ipst->ips_ipcl_dccp_conn_fanout_size * sizeof (connf_t), KM_SLEEP);
+	for (i = 0; i < ipst->ips_ipcl_dccp_conn_fanout_size; i++) {
+		mutex_init(&ipst->ips_ipcl_dccp_conn_fanout[i].connf_lock, NULL,
+		    MUTEX_DEFAULT, NULL);
+	}
+
+	ipst->ips_ipcl_dccp_bind_fanout = kmem_zalloc(
+	    ipst->ips_ipcl_dccp_bind_fanout_size * sizeof (connf_t), KM_SLEEP);
+	for (i = 0; i < ipst->ips_ipcl_dccp_bind_fanout_size; i++) {
+		mutex_init(&ipst->ips_ipcl_dccp_bind_fanout[i].connf_lock, NULL,
+		    MUTEX_DEFAULT, NULL);
+	}
 }
 
 void
@@ -487,6 +521,7 @@
 	kmem_cache_destroy(udp_conn_cache);
 	kmem_cache_destroy(rawip_conn_cache);
 	kmem_cache_destroy(rts_conn_cache);
+	kmem_cache_destroy(dccp_conn_cache);
 }
 
 /*
@@ -562,6 +597,22 @@
 	    sizeof (connf_t) * CONN_G_HASH_SIZE);
 	ipst->ips_ipcl_globalhash_fanout = NULL;
 
+	for (i = 0; i < ipst->ips_ipcl_dccp_conn_fanout_size; i++) {
+		ASSERT(ipst->ips_ipcl_dccp_conn_fanout[i].connf_head == NULL);
+		mutex_destroy(&ipst->ips_ipcl_dccp_conn_fanout[i].connf_lock);
+	}
+	kmem_free(ipst->ips_ipcl_dccp_conn_fanout,
+	    ipst->ips_ipcl_dccp_conn_fanout_size * sizeof (connf_t));
+	ipst->ips_ipcl_dccp_conn_fanout = NULL;
+
+	for (i = 0; i < ipst->ips_ipcl_dccp_bind_fanout_size; i++) {
+		ASSERT(ipst->ips_ipcl_dccp_bind_fanout[i].connf_head == NULL);
+		mutex_destroy(&ipst->ips_ipcl_dccp_bind_fanout[i].connf_lock);
+	}
+	kmem_free(ipst->ips_ipcl_dccp_bind_fanout,
+	    ipst->ips_ipcl_dccp_bind_fanout_size * sizeof (connf_t));
+	ipst->ips_ipcl_dccp_bind_fanout = NULL;
+
 	ASSERT(ipst->ips_rts_clients->connf_head == NULL);
 	mutex_destroy(&ipst->ips_rts_clients->connf_lock);
 	kmem_free(ipst->ips_rts_clients, sizeof (connf_t));
@@ -610,6 +661,10 @@
 		conn_cache = ip_conn_cache;
 		break;
 
+	case IPCL_DCCPCONN:
+		conn_cache = dccp_conn_cache;
+		break;
+
 	default:
 		connp = NULL;
 		ASSERT(0);
@@ -720,6 +775,33 @@
 		return;
 	}
 
+	if (connp->conn_flags & IPCL_DCCPCONN) {
+		dccp_t	*dccp = connp->conn_dccp;
+
+		cmn_err(CE_NOTE, "ipclassifier: conn_flags DCCP cache_free");
+
+		dccp_free(dccp);
+		mp = dccp->dccp_timercache;
+
+		dccp->dccp_dccps = NULL;
+
+		ipcl_conn_cleanup(connp);
+		connp->conn_flags = IPCL_DCCPCONN;
+		if (ns != NULL) {
+			ASSERT(dccp->dccps == NULL);
+			connp->conn_netstack = NULL;
+			connp->conn_ixa->ixa_ipst = NULL;
+			netstack_rele(ns);
+		}
+
+		bzero(dccp, sizeof (dccp_t));
+
+		dccp->dccp_timercache = mp;
+		dccp->dccp_connp = connp;
+		kmem_cache_free(dccp_conn_cache, connp);
+		return;
+	}
+
 	ipcl_conn_cleanup(connp);
 	if (ns != NULL) {
 		connp->conn_netstack = NULL;
@@ -1236,8 +1318,21 @@
 	case IPPROTO_SCTP:
 		ret = ipcl_sctp_hash_insert(connp, lport);
 		break;
+
+	case IPPROTO_DCCP:
+		cmn_err(CE_NOTE, "ipclassifier.c: ipcl_bind_insert_v4");
+		ASSERT(connp->conn_zoneid != ALL_ZONES);
+		connfp = &ipst->ips_ipcl_dccp_bind_fanout[
+		    IPCL_DCCP_BIND_HASH(lport, ipst)];
+		if (connp->conn_laddr_v4 != INADDR_ANY) {
+			IPCL_HASH_INSERT_BOUND(connfp, connp);
+		} else {
+			IPCL_HASH_INSERT_WILDCARD(connfp, connp);
+		}
+		break;
 	}
 
+
 	return (ret);
 }
 
@@ -1309,6 +1404,18 @@
 	case IPPROTO_SCTP:
 		ret = ipcl_sctp_hash_insert(connp, lport);
 		break;
+
+	case IPPROTO_DCCP:
+		cmn_err(CE_NOTE, "ipclassifier.c: ipcl_bind_insert_v6");
+		ASSERT(connp->conn_zoneid != ALL_ZONES);
+		connfp = &ipst->ips_ipcl_dccp_bind_fanout[
+		    IPCL_DCCP_BIND_HASH(lport, ipst)];
+		if (!IN6_IS_ADDR_UNSPECIFIED(&connp->conn_laddr_v6)) {
+			IPCL_HASH_INSERT_BOUND(connfp, connp);
+		} else {
+			IPCL_HASH_INSERT_WILDCARD(connfp, connp);
+		}
+		break;
 	}
 
 	return (ret);
@@ -1393,6 +1500,32 @@
 		ret = ipcl_sctp_hash_insert(connp, lport);
 		break;
 
+	case IPPROTO_DCCP:
+		cmn_err(CE_NOTE, "ipclassifier.c: ipcl_conn_insert_v4");
+		connfp = &ipst->ips_ipcl_dccp_conn_fanout[IPCL_DCCP_CONN_HASH(
+		    connp->conn_faddr_v4, connp->conn_ports, ipst)];
+		mutex_enter(&connfp->connf_lock);
+		for (tconnp = connfp->connf_head; tconnp != NULL;
+		    tconnp = tconnp->conn_next) {
+			if (IPCL_CONN_MATCH(tconnp, connp->conn_proto,
+			    connp->conn_faddr_v4, connp->conn_laddr_v4,
+			    connp->conn_ports) &&
+			    IPCL_ZONE_MATCH(tconnp, connp->conn_zoneid)) {
+				/* Already have a conn. bail out */
+				mutex_exit(&connfp->connf_lock);
+				return (EADDRINUSE);
+			}
+		}
+
+		/* XXX:DCCP XTI/TLI application? */
+
+		ASSERT(connp->conn_recv != NULL);
+		ASSERT(connp->conn_recvicmp != NULL);
+
+		IPCL_HASH_INSERT_CONNECTED_LOCKED(connfp, connp);
+		mutex_exit(&connfp->connf_lock);
+		break;
+
 	default:
 		/*
 		 * Check for conflicts among MAC exempt bindings.  For
@@ -1488,6 +1621,32 @@
 		ret = ipcl_sctp_hash_insert(connp, lport);
 		break;
 
+	case IPPROTO_DCCP:
+		cmn_err(CE_NOTE, "ipclassifier.c: ipcl_conn_insert_v6");
+		connfp = &ipst->ips_ipcl_dccp_conn_fanout[
+		    IPCL_DCCP_CONN_HASH_V6(connp->conn_faddr_v6,
+		    connp->conn_ports, ipst)];
+		mutex_enter(&connfp->connf_lock);
+		for (tconnp = connfp->connf_head; tconnp != NULL;
+		    tconnp = tconnp->conn_next) {
+			/* NOTE: need to match zoneid. Bug in onnv-gate */
+			if (IPCL_CONN_MATCH_V6(tconnp, connp->conn_proto,
+			    connp->conn_faddr_v6, connp->conn_laddr_v6,
+			    connp->conn_ports) &&
+			    (tconnp->conn_bound_if == 0 ||
+			    tconnp->conn_bound_if == ifindex) &&
+			    IPCL_ZONE_MATCH(tconnp, connp->conn_zoneid)) {
+				/* Already have a conn. bail out */
+				mutex_exit(&connfp->connf_lock);
+				return (EADDRINUSE);
+			}
+		}
+
+		/* XXX:DCCP XTI/TLI? */
+		IPCL_HASH_INSERT_CONNECTED_LOCKED(connfp, connp);
+		mutex_exit(&connfp->connf_lock);
+		break;
+
 	default:
 		if (is_system_labeled() &&
 		    check_exempt_conflict_v6(connp, ipst))
@@ -1655,6 +1814,67 @@
 
 		break;
 
+	case IPPROTO_DCCP:
+		ports = *(uint32_t *)up;
+
+		/*
+		 * Search for fully-bound connection.
+		 */
+		connfp = &ipst->ips_ipcl_dccp_conn_fanout[IPCL_DCCP_CONN_HASH(
+		    ipha->ipha_src, ports, ipst)];
+		mutex_enter(&connfp->connf_lock);
+		for (connp = connfp->connf_head; connp != NULL;
+		    connp = connp->conn_next) {
+			/* XXX:DCCP */
+			if (IPCL_CONN_MATCH(connp, protocol,
+			    ipha->ipha_src, ipha->ipha_dst, ports)) {
+				/* XXX */
+				cmn_err(CE_NOTE, "ipclassifier.c: fully bound connection found");
+				break;
+			}
+		}
+
+		if (connp != NULL) {
+			/*
+			 * We have a fully-bound DCCP connection.
+			 */
+			CONN_INC_REF(connp);
+			mutex_exit(&connfp->connf_lock);
+			return (connp);
+		}
+
+		mutex_exit(&connfp->connf_lock);
+		lport = up[1];
+
+		/*
+		 * Fully-bound connection was not found, search for listener.
+		 */
+		bind_connfp = &ipst->ips_ipcl_dccp_bind_fanout[
+		    IPCL_DCCP_BIND_HASH(lport, ipst)];
+		mutex_enter(&bind_connfp->connf_lock);
+		for (connp = bind_connfp->connf_head; connp != NULL;
+		    connp = connp->conn_next) {
+			if (IPCL_BIND_MATCH(connp, protocol, ipha->ipha_dst,
+			    lport) &&
+			    (connp->conn_zoneid == zoneid ||
+			    connp->conn_allzones ||
+			    ((connp->conn_mac_mode != CONN_MAC_DEFAULT) &&
+			    (ira->ira_flags & IRAF_TX_MAC_EXEMPTABLE) &&
+			    (ira->ira_flags & IRAF_TX_SHARED_ADDR))))
+				break;
+		}
+
+		if (connp != NULL) {
+			cmn_err(CE_NOTE, "ipclassifier.c: half-bound bind listener");
+			/* Have a listener at least */
+			CONN_INC_REF(connp);
+			mutex_exit(&bind_connfp->connf_lock);
+			return (connp);
+		}
+
+		mutex_exit(&bind_connfp->connf_lock);
+		break;
+
 	case IPPROTO_ENCAP:
 	case IPPROTO_IPV6:
 		return (ipcl_iptun_classify_v4(&ipha->ipha_src,
@@ -2175,6 +2395,70 @@
 	}
 }
 
+/* ARGSUSED */
+static int
+dccp_conn_constructor(void *buf, void *cdrarg, int kmflags)
+{
+	itc_t	*itc = (itc_t *)buf;
+	conn_t	*connp = &itc->itc_conn;
+	dccp_t	*dccp = (dccp_t *)&itc[1];
+
+	bzero(connp, sizeof (conn_t));
+	bzero(dccp, sizeof (dccp_t));
+
+	mutex_init(&connp->conn_lock, NULL, MUTEX_DEFAULT, NULL);
+	cv_init(&connp->conn_cv, NULL, CV_DEFAULT, NULL);
+	rw_init(&connp->conn_ilg_lock, NULL, RW_DEFAULT, NULL);
+
+	dccp->dccp_timercache = dccp_timermp_alloc(kmflags);
+	if (dccp->dccp_timercache == NULL) {
+		return (ENOMEM);
+	}
+
+	connp->conn_dccp = dccp;
+	connp->conn_flags = IPCL_DCCPCONN;
+	connp->conn_proto = IPPROTO_DCCP;
+	dccp->dccp_connp = connp;
+
+	connp->conn_ixa = kmem_zalloc(sizeof (ip_xmit_attr_t), kmflags);
+	if (connp->conn_ixa == NULL) {
+		return (NULL);
+	}
+
+	connp->conn_ixa->ixa_refcnt = 1;
+	connp->conn_ixa->ixa_protocol = connp->conn_proto;
+	connp->conn_ixa->ixa_xmit_hint = CONN_TO_XMIT_HINT(connp);
+
+	return (0);
+}
+
+/* ARGSUSED */
+static void
+dccp_conn_destructor(void *buf, void *cdrarg)
+{
+	itc_t	*itc = (itc_t *)buf;
+	conn_t	*connp = &itc->itc_conn;
+	dccp_t	*dccp = (dccp_t *)&itc[1];
+
+	ASSERT(connp->conn_flags & IPCL_DCCPCONN);
+	ASSERT(dccp->dccp_connp == connp);
+	ASSERT(connp->conn_dccp == dccp);
+
+	dccp_timermp_free(dccp);
+
+	mutex_destroy(&connp->conn_lock);
+	cv_destroy(&connp->conn_cv);
+	rw_destroy(&connp->conn_ilg_lock);
+
+	if (connp->conn_ixa != NULL) {
+		ASSERT(connp->conn_ixa->ixa_refcnt == 1);
+		ASSERT(connp->conn_ixa->ixa_ire == NULL);
+		ASSERT(connp->conn_ixa->ixa_nce == NULL);
+
+		ixa_refrele(connp->conn_ixa);
+	}
+}
+
 /*
  * Called as part of ipcl_conn_destroy to assert and clear any pointers
  * in the conn_t.
@@ -2554,6 +2838,82 @@
 }
 
 /*
+ * Same as ipcl_tcp_lookup_reversed_ipv4.
+ */
+conn_t *
+ipcl_dccp_lookup_reversed_ipv4(ipha_t *ipha, dccpha_t *dccpha, int min_state,
+    ip_stack_t *ipst)
+{
+	conn_t		*tconnp;
+	connf_t		*connfp;
+	uint16_t	*pports;
+	uint32_t	ports;
+
+	pports = (uint16_t *)&ports;
+	pports[0] = dccpha->dha_fport;
+	pports[1] = dccpha->dha_lport;
+
+	connfp = &ipst->ips_ipcl_dccp_conn_fanout[IPCL_DCCP_CONN_HASH(
+	    ipha->ipha_dst, ports, ipst)];
+
+	mutex_enter(&connfp->connf_lock);
+	for (tconnp = connfp->connf_head; tconnp != NULL;
+	    tconnp = tconnp->conn_next) {
+		if (IPCL_CONN_MATCH(tconnp, IPPROTO_DCCP,
+		    ipha->ipha_dst, ipha->ipha_src, ports) &&
+		    tconnp->conn_dccp->dccp_state >= min_state) {
+			CONN_INC_REF(tconnp);
+			mutex_exit(&connfp->connf_lock);
+			return (tconnp);
+		}
+	}
+	mutex_exit(&connfp->connf_lock);
+
+	return (NULL);
+}
+
+/*
+ * Same as ipcl_tcp_lookup_reversed_ipv6.
+ */
+conn_t *
+ipcl_dccp_lookup_reversed_ipv6(ip6_t *ip6h, dccpha_t *dccpha, int min_state,
+    uint_t ifindex, ip_stack_t *ipst)
+{
+	conn_t		*tconnp;
+	tcp_t		*tcp;
+	connf_t		*connfp;
+	uint32_t	 ports;
+	uint16_t	 *pports;
+
+	pports = (uint16_t *)&ports;
+	pports[0] = dccpha->dha_fport;
+	pports[1] = dccpha->dha_lport;
+/*
+	connfp = &ipst->ips_ipcl_conn_fanout[IPCL_CONN_HASH_V6(ip6h->ip6_dst,
+	    ports, ipst)];
+
+	mutex_enter(&connfp->connf_lock);
+	for (tconnp = connfp->connf_head; tconnp != NULL;
+	    tconnp = tconnp->conn_next) {
+
+		tcp = tconnp->conn_tcp;
+		if (IPCL_CONN_MATCH_V6(tconnp, IPPROTO_TCP,
+		    ip6h->ip6_dst, ip6h->ip6_src, ports) &&
+		    tcp->tcp_state >= min_state &&
+		    (tconnp->conn_bound_if == 0 ||
+		    tconnp->conn_bound_if == ifindex)) {
+
+			CONN_INC_REF(tconnp);
+			mutex_exit(&connfp->connf_lock);
+			return (tconnp);
+		}
+	}
+	mutex_exit(&connfp->connf_lock);
+*/
+	return (NULL);
+}
+
+/*
  * Finds a TCP/IPv4 listening connection; called by tcp_disconnect to locate
  * a listener when changing state.
  */
--- old/usr/src/uts/common/inet/ip_impl.h	2012-08-18 10:37:17.551908274 +0000
+++ new/usr/src/uts/common/inet/ip_impl.h	2012-08-18 10:37:17.581212918 +0000
@@ -52,11 +52,13 @@
 #define	IP_TCP_CSUM_COMP	IPPROTO_TCP
 #define	IP_UDP_CSUM_COMP	IPPROTO_UDP
 #define	IP_ICMPV6_CSUM_COMP	IPPROTO_ICMPV6
+#define	IP_DCCP_CSUM_COMP	IPPROTO_DCCP
 #else
 #define	IP_HDR_CSUM_TTL_ADJUST	1
 #define	IP_TCP_CSUM_COMP	(IPPROTO_TCP << 8)
 #define	IP_UDP_CSUM_COMP	(IPPROTO_UDP << 8)
 #define	IP_ICMPV6_CSUM_COMP	(IPPROTO_ICMPV6 << 8)
+#define	IP_DCCP_CSUM_COMP	(IPPROTO_DCCP << 8)
 #endif
 
 #define	TCP_CHECKSUM_OFFSET	16
@@ -68,6 +70,9 @@
 #define	ICMPV6_CHECKSUM_OFFSET	2
 #define	ICMPV6_CHECKSUM_SIZE	2
 
+#define	DCCP_CHECKSUM_OFFSET	6
+#define	DCCP_CHECKSUM_SIZE	2
+
 #define	IPH_TCPH_CHECKSUMP(ipha, hlen)	\
 	((uint16_t *)(((uchar_t *)(ipha)) + ((hlen) + TCP_CHECKSUM_OFFSET)))
 
@@ -77,6 +82,9 @@
 #define	IPH_ICMPV6_CHECKSUMP(ipha, hlen)	\
 	((uint16_t *)(((uchar_t *)(ipha)) + ((hlen) + ICMPV6_CHECKSUM_OFFSET)))
 
+#define	IPH_DCCPH_CHECKSUMP(ipha, hlen)	\
+	((uint16_t *)(((uchar_t *)(ipha)) + ((hlen) + DCCP_CHECKSUM_OFFSET)))
+
 #define	ILL_HCKSUM_CAPABLE(ill)		\
 	(((ill)->ill_capabilities & ILL_CAPAB_HCKSUM) != 0)
 
--- old/usr/src/uts/common/inet/ip_stack.h	2012-08-18 10:37:17.903956817 +0000
+++ new/usr/src/uts/common/inet/ip_stack.h	2012-08-18 10:37:17.927105196 +0000
@@ -195,11 +195,15 @@
 	struct connf_s	*ips_ipcl_udp_fanout;
 	struct connf_s	*ips_ipcl_raw_fanout;		/* RAW SCTP sockets */
 	struct connf_s	*ips_ipcl_iptun_fanout;
+	struct connf_s	*ips_ipcl_dccp_conn_fanout;
+	struct connf_s	*ips_ipcl_dccp_bind_fanout;
 	uint_t		ips_ipcl_conn_fanout_size;
 	uint_t		ips_ipcl_bind_fanout_size;
 	uint_t		ips_ipcl_udp_fanout_size;
 	uint_t		ips_ipcl_raw_fanout_size;
 	uint_t		ips_ipcl_iptun_fanout_size;
+	uint_t		ips_ipcl_dccp_conn_fanout_size;
+	uint_t		ips_ipcl_dccp_bind_fanout_size;
 	struct connf_s	*ips_ipcl_globalhash_fanout;
 	int		ips_conn_g_index;
 
--- old/usr/src/uts/common/inet/ipclassifier.h	2012-08-18 10:37:18.307940574 +0000
+++ new/usr/src/uts/common/inet/ipclassifier.h	2012-08-18 10:37:18.342763040 +0000
@@ -34,6 +34,7 @@
 #include <inet/ip.h>
 #include <inet/mi.h>
 #include <inet/tcp.h>
+#include <inet/dccp.h>
 #include <inet/ip6.h>
 #include <netinet/in.h>		/* for IPPROTO_* constants */
 #include <sys/sdt.h>
@@ -84,7 +85,7 @@
 #define	IPCL_UDPCONN		0x00000008	/* From udp_conn_cache */
 #define	IPCL_RAWIPCONN		0x00000010	/* From rawip_conn_cache */
 #define	IPCL_RTSCONN		0x00000020	/* From rts_conn_cache */
-/* Unused			0x00000040 */
+#define	IPCL_DCCPCONN		0x00000040	/* From dccp_conn_cache */
 #define	IPCL_IPTUN		0x00000080	/* iptun module above us */
 
 #define	IPCL_NONSTR		0x00001000	/* A non-STREAMS socket */
@@ -121,6 +122,9 @@
 #define	IPCL_IS_IPTUN(connp)						\
 	((connp)->conn_flags & IPCL_IPTUN)
 
+#define	IPCL_IS_DCCP(connp)						\
+	((connp)->conn_flags & IPCL_DCCPCONN)
+
 #define	IPCL_IS_NONSTR(connp)	((connp)->conn_flags & IPCL_NONSTR)
 
 typedef struct connf_s connf_t;
@@ -237,6 +241,7 @@
 		struct rts_s	*cp_rts;	/* Pointer to rts struct */
 		struct iptun_s	*cp_iptun;	/* Pointer to iptun_t */
 		struct sctp_s	*cp_sctp;	/* For IPCL_SCTPCONN */
+		struct dccp_s	*cp_dccp;	/* Pointer to dccp struct */
 		void		*cp_priv;
 	} conn_proto_priv;
 #define	conn_tcp	conn_proto_priv.cp_tcp
@@ -245,6 +250,7 @@
 #define	conn_rts	conn_proto_priv.cp_rts
 #define	conn_iptun	conn_proto_priv.cp_iptun
 #define	conn_sctp	conn_proto_priv.cp_sctp
+#define	conn_dccp	conn_proto_priv.cp_dccp
 #define	conn_priv	conn_proto_priv.cp_priv
 
 	kcondvar_t	conn_cv;
@@ -651,6 +657,18 @@
 #define	IPCL_UDP_HASH(lport, ipst)	\
 	IPCL_PORT_HASH(lport, (ipst)->ips_ipcl_udp_fanout_size)
 
+#define	IPCL_DCCP_CONN_HASH(src, ports, ipst)				\
+	((unsigned)(ntohl((src)) ^ ((ports) >> 24) ^ ((ports) >> 16) ^	\
+	((ports) >> 8) ^ (ports)) % (ipst)->ips_ipcl_dccp_conn_fanout_size)
+
+#define	IPCL_DCCP_CONN_HASH_V6(src, ports, ipst)			\
+	IPCL_DCCP_CONN_HASH(V4_PART_OF_V6((src)), (ports), (ipst))
+
+#define	IPCL_DCCP_BIND_HASH(lport, ipst)				\
+	((unsigned)(((lport) >> 8) ^ (lport)) %				\
+	    (ipst)->ips_ipcl_dccp_bind_fanout_size)
+
+
 #define	CONN_G_HASH_SIZE	1024
 
 /* Raw socket hash function. */
@@ -710,6 +728,11 @@
 conn_t	*ipcl_tcp_lookup_reversed_ipv4(ipha_t *, tcpha_t *, int, ip_stack_t *);
 conn_t	*ipcl_tcp_lookup_reversed_ipv6(ip6_t *, tcpha_t *, int, uint_t,
 	    ip_stack_t *);
+/*
+conn_t	*ipcl_dccp_lookup_reversed_ipv4(ipha_t *, dccpha_t *, int, ip_stack_t *);
+conn_t	*ipcl_dccp_lookup_reversed_ipv6(ip6_t *, dccpha_t *, int, uint_t,
+	    ip_stack_t *);
+*/
 conn_t	*ipcl_lookup_listener_v4(uint16_t, ipaddr_t, zoneid_t, ip_stack_t *);
 conn_t	*ipcl_lookup_listener_v6(uint16_t, in6_addr_t *, uint_t, zoneid_t,
 	    ip_stack_t *);
--- old/usr/src/uts/common/inet/kstatcom.h	2012-08-18 10:37:18.629848192 +0000
+++ new/usr/src/uts/common/inet/kstatcom.h	2012-08-18 10:37:18.653441511 +0000
@@ -467,6 +467,12 @@
 	kstat_named_t outErrors;
 } rawip_named_kstat_t;
 
+typedef struct dccp_named_kstat {
+	kstat_named_t activeOpens;
+	kstat_named_t passiveOpens;
+	kstat_named_t inSegs;
+	kstat_named_t outSegs;
+} dccp_named_kstat_t;
 
 #define	NUM_OF_FIELDS(S)	(sizeof (S) / sizeof (kstat_named_t))
 
--- old/usr/src/uts/common/inet/mib2.h	2012-08-18 10:37:18.893817909 +0000
+++ new/usr/src/uts/common/inet/mib2.h	2012-08-18 10:37:18.919544870 +0000
@@ -96,12 +96,14 @@
 #define	MIB2_TCP6		(IPPROTO_MAX+14)
 #define	MIB2_UDP6		(IPPROTO_MAX+15)
 #define	MIB2_SCTP		(IPPROTO_MAX+16)
+#define	MIB2_DCCP		(IPPROTO_MAX+17)
+#define	MIB2_DCCP6		(IPPROTO_MAX+18)
 
 /*
  * Define range of levels for use with MIB2_*
  */
 #define	MIB2_RANGE_START	(IPPROTO_MAX+1)
-#define	MIB2_RANGE_END		(IPPROTO_MAX+16)
+#define	MIB2_RANGE_END		(IPPROTO_MAX+18)
 
 
 #define	EXPER			1024	/* experimental - not part of mib */
@@ -1786,6 +1788,134 @@
 #pragma pack()
 #endif
 
+/*
+ * the DCCP group
+ */
+#define	MIB2_DCCP_CONN		18
+#define	MIB2_DCCP6_CONN		19
+
+#define	MIB2_DCCP_closed	1
+#define	MIB2_DCCP_listen	2
+
+/* Pack data to make struct size the same for 32- and 64-bits */
+#if _LONG_LONG_ALIGNMENT == 8 && _LONG_LONG_ALIGNMENT_32 == 4
+#pragma pack(4)
+#endif
+
+typedef struct mib2_dccp {
+
+		/* # of direct transitions CLOSED -> ACK-SENT	{ dccp 5 } */
+	Counter	dccpActiveOpens;
+		/* # of direct transitions LISTEN -> ACK-RCVD	{ dccp 6 } */
+	Counter	dccpPassiveOpens;
+		/* # of direct SIN-SENT/RCVD -> CLOSED/LISTEN	{ dccp 7 } */
+	Counter	dccpAttemptFails;
+		/* # of direct ESTABLISHED/CLOSE-WAIT -> CLOSED	{ dccp 8 } */
+	Counter	dccpEstabResets;
+		/* # of connections ESTABLISHED or CLOSE-WAIT	{ dccp 9 } */
+	Gauge	dccpCurrEstab;
+		/* total # of segments recv'd			{ dccp 10 } */
+	Counter	dccpInSegs;
+		/* total # of segments sent			{ dccp 11 } */
+	Counter	dccpOutSegs;
+		/* total # of segments retransmitted		{ dccp 12 } */
+	Counter	dccpRetransSegs;
+
+	Counter dccpTimRetrans;
+	/* total # of retransmit timeouts dropping the connection */
+	Counter dccpTimRetransDrop;
+	/* total # of keepalive timeouts */
+	Counter dccpTimKeepalive;
+	/* total # of keepalive timeouts sending a probe */
+	Counter dccpTimKeepaliveProbe;
+	/* total # of keepalive timeouts dropping the connection */
+	Counter dccpTimKeepaliveDrop;
+
+	Counter	dccpOutDataSegs;
+	Counter dccpOutDataBytes;
+
+	int	dccpEntrySize;
+	int	dccp6EntrySize;
+
+	int	dccpConnTableSize;
+	int	dccp6ConnTableSize;
+
+	Counter64	dccpHCInDatagrams;
+	/* total # of segments recv'd				{ tcp 17 } */
+	Counter64	dccpHCInSegs;
+	/* total # of segments sent				{ tcp 18 } */
+	Counter64	dccpHCOutSegs;
+} mib2_dccp_t;
+#define	MIB_FIRST_NEW_ELM_mib2_dccp_t	dccpHCInDatagrams
+
+#if _LONG_LONG_ALIGNMENT == 8 && _LONG_LONG_ALIGNMENT_32 == 4
+#pragma pack()
+#endif
+
+/* Pack data to make struct size the same for 32- and 64-bits */
+#if _LONG_LONG_ALIGNMENT == 8 && _LONG_LONG_ALIGNMENT_32 == 4
+#pragma pack(4)
+#endif
+
+typedef struct mib2_dccpConnEntry {
+	int		dccpConnState;
+	IpAddress	dccpConnLocalAddress;
+	int		dccpConnLocalPort;
+	IpAddress	dccpConnRemAddress;
+	int		dccpConnRemPort;
+
+	struct dccpConnEntryInfo_s {
+				/* current rto (retransmit timeout) */
+		Gauge		ce_rto;
+				/* current max segment size */
+		Gauge		ce_mss;
+				/* actual internal state */
+		int		ce_state;
+	} dccpConnEntryInfo;
+
+	uint32_t	dccpConnCreationProcess;
+	uint64_t	dccpConnCreationTime;
+} mib2_dccpConnEntry_t;
+#define	MIB_FIRST_NEW_ELM_mib2_dccpConnEntry_t	dccpConnCreationProcess
+
+#if _LONG_LONG_ALIGNMENT == 8 && _LONG_LONG_ALIGNMENT_32 == 4
+#pragma pack()
+#endif
+
+/* Pack data to make struct size the same for 32- and 64-bits */
+#if _LONG_LONG_ALIGNMENT == 8 && _LONG_LONG_ALIGNMENT_32 == 4
+#pragma pack(4)
+#endif
+
+typedef struct mib2_dccp6ConnEntry {
+	Ip6Address	dccp6ConnLocalAddress;
+	int		dccp6ConnLocalPort;
+	Ip6Address	dccp6ConnRemAddress;
+	int		dccp6ConnRemPort;
+	/* Interface index or zero		{ ipv6DccpConnEntry 5 } */
+	DeviceIndex	dccp6ConnIfIndex;
+	/* State of dccp6 connection		{ ipv6DccpConnEntry 6 } RW */
+	int		dccp6ConnState;
+
+	struct dccp6ConnEntryInfo_s {
+				/* current rto (retransmit timeout) */
+		Gauge		ce_rto;
+				/* current max segment size */
+		Gauge		ce_mss;
+				/* actual internal state */
+		int		ce_state;
+	} dccp6ConnEntryInfo;
+
+	/* PID of the processes that created this connection */
+	uint32_t	dccp6ConnCreationProcess;
+	/* System uptime when the connection was created */
+	uint64_t	dccp6ConnCreationTime;
+} mib2_dccp6ConnEntry_t;
+#define	MIB_FIRST_NEW_ELM_mib2_dccp6ConnEntry_t	dccp6ConnCreationProcess
+
+#if _LONG_LONG_ALIGNMENT == 8 && _LONG_LONG_ALIGNMENT_32 == 4
+#pragma pack()
+#endif
 
 #ifdef	__cplusplus
 }
